<?php


/** support for widgets **/
/** http://automattic.com/code/widgets/themes/ **/

function tomk32_widget_links($args) {
	global $wp_db_version;
	extract($args);
	$style = get_option('tomk32_widget_links');
	if ($style != 'multiple') {
		echo $before_widget, $before_title, __('Links'), $after_title;
		$after_copy = $after_widget;
		$after_widget = $before_widget = "";
	}
	if ( $wp_db_version < 3582 ) {
		// This ONLY works with li/h2 sidebars.
		get_links_list();
	} else {
	  if ($style != 'multiple') {
	    echo '<ul>';
	    wp_list_bookmarks(array('title_before' => '<strong>', 
				    'title_after' => '</strong>'));
	    echo '</ul>';
	  } else
	    wp_list_bookmarks(array('category_before' => $before_widget, 
				    'category_after' => $after_widget, 
				    'title_before'=>$before_title, 
				    'title_after'=>$after_title));
	}
	if ($style != 'multiple')
		echo $after_copy;
}

function tomk32_widget_links_control() {
	if (isset($_POST['tomk32_widget_links']) && in_array($_POST['tomk32_widget_links'], array('single', 'multiple')))
		update_option('tomk32_widget_links', $_POST['tomk32_widget_links']);
	$style = get_option('tomk32_widget_links');
	if (empty($style)) $style = 'multiple';
?>
	<div>
		<label><?php _e('Display in a single box or multiple? Single is the better choice if you have many link-categories.'); ?><br />
			<select name="tomk32_widget_links">
				<option value="single"<?php echo ($style == 'single') ? 'selected="selected"' : ""; ?>><?php _e('Single'); ?></option>
				<option value="multiple"<?php echo ($style == 'multiple') ? 'selected="selected"' : ""; ?>><?php _e('Multiple'); ?></option>
			</select>
		</label>
	</div>
<?php
}

function widget_wp_theme_switcher($args) {
	extract($args);
	echo $before_widget;
	echo '<div class="title">', __('Themes'), '</div>';
	wp_theme_switcher();
	echo $after_widget;
}

function tomk32_widget_search($args) {
	extract($args);
?>
		<?php echo $before_widget; ?>
			<div class="title"><?php _e('Search'); ?></div>
			<form id="searchform" method="get" action="<?php bloginfo('home'); ?>">
			<div>
			<input type="text" name="s" id="s" size="15" /><br />
			<input type="submit" value="<?php _e('Search'); ?>" />
			</div>
			</form>
		<?php echo $after_widget; ?>
<?php
}
function tomk32_theme_widgets() {
	register_sidebar(array(
		'before_widget' => '
<div class="portlet" id="%1$s">',
		'after_widget' => '</div>',
		'before_title' => '
<div class="title">',
		'after_title' => '</div>',
	));

	register_sidebar_widget(__('Links') . ' (TomK32 theme)', 'tomk32_widget_links');
	register_widget_control(__('Links') . ' (TomK32 theme)', 'tomk32_widget_links_control');
	register_sidebar_widget(__('Search') . ' (TomK32 theme)', 'tomk32_widget_search');
	register_sidebar_widget('Theme switcher', 'widget_wp_theme_switcher');

}
add_action('widgets_init', tomk32_theme_widgets);



function tomk32_add_theme_page() {
	if ( $_GET['page'] == basename(__FILE__) ) {
		if (isset($_REQUEST['tomk32_theme_numfullentries']))
			update_option('tomk32_theme_numfullentries', intval($_REQUEST['tomk32_theme_numfullentries']));
		if (is_array($_REQUEST['tomk32_theme_widgets']))
			update_option('tomk32_theme_widgets', $_REQUEST['tomk32_theme_widgets']);
		elseif ( 'save' == $_REQUEST['action'] ) {
		}
	}
	add_theme_page(__('Configure theme'), __('Configure theme'), 'edit_themes', basename(__FILE__), 'tomk32_theme_page');
}

add_action('admin_menu', 'tomk32_add_theme_page');


function tomk32_theme_page() {
	if ( $_REQUEST['saved'] ) echo '<div id="message" class="updated fade"><p><strong>', __('Modifications have been saved'), '</strong></p></div>';
?>
<div class='wrap'>
<h2><?php _e('General settings'); ?></h2>
<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post">
<fieldset>
<table class="optiontable">
<?php 
$sidebars_widgets = get_option('sidebars_widgets');
if (function_exists('widgets_init') && ! empty($sidebars_widgets)) : 
	$tomk32_theme_widgets = get_option('tomk32_theme_widgets');
?>
	<tr><th scope="row"><label for="tomk32_theme_widgets"><?php _e('Widgets to be fully shown. This works globally and not (yet) per sidebar. The collapsed widgets can be uncollapsed with a click.'); ?></label>
</th><td>
	<fieldset name="tomk32_theme_widgets" id="tomk32_theme_widgets">
<?php foreach ($sidebars_widgets as $sidebar => $s_widgets) : ?>
	<h3><?php echo $sidebar; ?></h3>
	<ul style="list-style: none;">
<?php
	foreach ($s_widgets as $widget) : 
	$checked = "";
	if (isset($tomk32_theme_widgets[$sidebar][$widget])) $checked = 'checked="checked"';
?>
	<li><label><input type="checkbox"<?php echo " $checked"; ?> name="tomk32_theme_widgets[<?php echo $sidebar, '][', $widget;?>]" value="1" /> <?php echo $widget; ?></label></li>
<?php endforeach; ?>
	</ul>
	<?php endforeach; ?>
</fieldset>
	</td></tr>
<?php endif; ?>
<?php $tomk32_theme_numfullentries = get_option('tomk32_theme_numfullentries');
if ($tomk32_theme_numfullentries < 1) $tomk32_theme_numfullentries = 5; ?>
	<tr><th scope="row"><label for="tomk32_theme_numfullentries"><?php _e('How many posts should be fully shown on the frontpage?'); ?></label>
</th><td>
<input name="tomk32_theme_numfullentries" type="text" id="tomk32_theme_numfullentries" value="<?php echo $tomk32_theme_numfullentries; ?>" size="3" /> <?php printf(__('posts of %s'), get_option('posts_per_page')); ?>
	</td></tr>
<?php if (!function_exists('widgets_init') && empty($registered_widgets)) : ?>
	<tr><th scope="row"><label for="blog_about"><?php _e("Text about the blog. Leave blank if you don't want to display the about box"); ?></label></th>
	<td><textarea name="aboutText" id="blog_about"><?php wp_special_chars(get_option('blog_about')); ?></textarea></td>
	</tr>

<?php endif; ?>
<tr><td colspan="2">
	<input type="submit" />
</table>
</fieldset>
</form>

</div>
<?php
}

/** some Javascript **/
function tomk32_theme_head() {
	global $registered_widgets;
	$sidebar_widgets = get_option('sidebars_widgets');
	if ( empty($sidebar_widgets) || ! function_exists('dynamic_sidebar')) return;


	$tomk32_theme_widgets = get_option('tomk32_theme_widgets');
	echo '<script type="text/javascript" language="Javascript">
$(document).ready( function() {
';
	foreach ($tomk32_theme_widgets as $sidebar => $widgets) {
		foreach ($widgets as $widget => $tmp) {
			if (in_array($widget, $sidebar_widgets[$sidebar])) 
			echo "	$('#" , $registered_widgets[$widget]['id'], " .title').addClass('show');\n";
	}
	}
	echo '});
</script>
';
}

add_action('wp_head', 'tomk32_theme_head');

?>